<template>
    <search class="w-10/12 flex justify-center content-center">
      <div class="flex flex-row flex-wrap w-full gap-2 rounded p-2 border-0 shadow bg-white">
        <div class="w-2/12">
          <select v-model="searchCity" class="w-full bg-gray-3 p-1 rounded text-gray-2 font-semibold">
            <option value="" selected hidden disabled>where to go?</option>
            <option  v-for="city in cities" :key="city.id" :value="city.city_name ">
              {{ city.city_name }}
            </option>
          </select>
        </div>
        <div class="w-36">
          <input v-model="checkIn"  type="date"
           class="w-full p-1 bg-gray-3 rounded text-gray-2 font-semibold" 
            id="checkin" name="checkin" placeholder="check in date" />
        </div>
        <div class="w-36">
          <input v-model="checkOut" type="date" class="w-full p-1 bg-gray-3 rounded text-gray-2 font-semibold" id="checkout" name="checkout" placeholder="check out date" />
        </div>
        <div class="w-36">
          <input v-model="guests" class="w-full p-1 bg-gray-3 rounded text-gray-2 font-semibold" type="text" placeholder="Guests" />
        </div>
        <div class="w-36">
          <input v-model="rooms" class="w-full p-1 bg-gray-3 rounded text-gray-2 font-semibold" type="text" placeholder="Rooms" />
        </div>
        <div class="w-28">
          <router-link :to="{ name: 'Reservation'}">
            <button @click="searchHotels" class="bg-blue-1 w-full py-1 rounded text-white-1">Search</button>
          </router-link>
        </div>
      </div>
    </search>
  </template>
  
  <script>
import axios from "axios";
  import { onMounted, ref,onUpdated,watch } from "vue";
  
  export default {
    name: "SearchBar",
    setup(_, { emit }) {
      const hotels = ref([]);
      const dest_id = ref('');
      const searchCity = ref('');
      const cities = ref([]);
      const checkIn=ref('')
      const checkOut=ref('')
      const guests=ref('') 
      const rooms=ref('') 
      const key=import.meta.env.VUE_APP_API_KEY
      const getCities = async () => {
        try {
          const options = {
            method: 'GET',
            url: 'https://booking-com15.p.rapidapi.com/api/v1/hotels/searchDestination',
            params: { query: 'egypt' },
            headers: {
              'X-RapidAPI-Key':"697b6c9edemsh526d9e9a0a48f3bp14de13jsnfe4de2ac8fae",
              'X-RapidAPI-Host': 'booking-com15.p.rapidapi.com',
            },
          };
          const response = await axios.request(options);
          cities.value = response.data.data;
        } catch (error) {
          console.error('Error fetching cities:', error);
        }
      };
  
      const searchHotels = async()=> {
        try {
          for (let i = 0; i < cities.value.length; i++) {
            if (cities.value[i].city_name === searchCity.value) {
              dest_id.value = cities.value[i].dest_id ||"-2092174";
              localStorage.setItem('dest_id', cities.value[i].dest_id)
              localStorage.setItem('searchCity', searchCity.value);
            }
          }
          
          // console.log(dest_id.value);
          const options = {
            method: 'GET',
            url: 'https://booking-com15.p.rapidapi.com/api/v1/hotels/searchHotels',
            params: {
              dest_id: localStorage.getItem('dest_id'),
              search_type: 'City',
              arrival_date: '2023-12-05',
              departure_date: '2023-12-10',
            },
            headers: {
              'X-RapidAPI-Key': "697b6c9edemsh526d9e9a0a48f3bp14de13jsnfe4de2ac8fae",
              'X-RapidAPI-Host': 'booking-com15.p.rapidapi.com',
            },
          };
          // console.log(await axios.request(options));
          const response = await axios.request(options);
          hotels.value = response.data.data.hotels;
          localStorage.setItem('hotels', JSON.stringify(hotels.value));
          emit('updateSearchCity',searchCity.value)
          emit('updateHotels', hotels.value);
          
        } catch (error) {
          error.value = 'An error occurred while fetching hotels.';
        }
      };
     watch(()=>{
      localStorage.getItem('dest_id')
      // localStorage.setItem('searchCity',searchCity.value)
     })
      onMounted(() => {
        getCities();
        searchHotels()
      });
  
      return { searchCity, cities, getCities, dest_id, hotels, searchHotels };
    },
  };
  </script>
  